# -*- coding: utf-8 -*-

import odoo

from odoo import api, models
from odoo.addons.saas_worker.const import TEST

import logging
_logger = logging.getLogger(__name__)


class ServerAction(models.Model):

    _inherit = 'ir.actions.server'

    @api.model
    def _get_eval_context(self, action=None):
        eval_context = super(ServerAction, self)._get_eval_context(action)

        eval_context.update(
            # AuthenticationError can be raised inside server actions to rollback a transaction
            # and return a JSON reponse with an error.code 100 instead of the usual error.code 200.
            # This is used for example by openerp-smtpd to detect discarded messages that should
            # not be bounced like regular delivery errors (DISCARD vs REJECT)
            # In s15.3, AuthenticationError has been dropped, we use SessionExpiredException to keep
            # the old code compatible, and keep a status code 100
            AuthenticationError=odoo.http.SessionExpiredException,

            # Allow debug without raise UserError that rollback
            _log=_logger.warning,
        )

        if TEST:
            eval_context.update(
                _print=print,
            )

        return eval_context
